<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META NAME="generator" CONTENT="http://txt2tags.org">
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf8">
<LINK REL="stylesheet" TYPE="text/css" HREF="../../style/style.css">
</HEAD><BODY BGCOLOR="white" TEXT="black">
<CENTER>
</CENTER>


<H1>Procurando e copiando arquivos com seus caminhos originais</H1>

<P>
<B><I>Colaboração: Paulo Roberto Bagatini</I></B>
</P>
<P>
<B><I>Data de Publicação: 30 de março de 2015</I></B>
</P>
<P>
Ao longo dos anos fui amontoando alguns arquivos .reg com configuração personalizada do PuTTY. Não é muita coisa, mas está tudo espalhado em um HD USB com mais de 1 TiB de dados e não há a menor chance de lembrar quantos são, em que diretórios estão e como se chamam; só sei que provavelmente têm "putty" no nome, alguma alternância entre maiúsculo e minúsculo, e a extensão é "reg".
</P>
<P>
Como achá-los e copiá-los automaticamente para um único diretório, cuidando para não sobrescrever os que tiverem o mesmo nome? Bom, se cada arquivo for copiado com seu caminho original para dentro do novo diretório "pai", certamente não haverá nenhuma sobreposição.
</P>
<P>
A <B>primeira técnica</B> será a forma rápida, limpa e suficientemente nerd de fazer isso (no Unix, MacOSX e Windows com <A HREF="http://goo.gl/lu6oJi">CygWin</A>): com um singelo <I>cp</I> associado a um <I>find</I>.
</P>
<P>
Primeiro preparamos adequadamente o ambiente:
</P>

<PRE>
  $ padrao="*putty*.reg"
  $ pesquisa="/longa/raiz/comum/a/todos/os/arquivos/e/que/nao/interessa/manter/"
  $ destino="/diretorio/para/os/arquivos/encontrados/"
  $ mkdir -p "$destino"
  $ alias time="/usr/bin/time -f %E"
</PRE>

<P>
Então executamos o comando:
</P>

<PRE>
  $ ( cd "$pesquisa"; cp -va --parents $(time find . -type f -iname "$padrao") "$destino" )
</PRE>

<P>
O <I>alias</I> do comando <I>time</I> é apenas um plus a mais :-p para saber em um formato user friendly quanto tempo a pesquisa do <I>find</I> demorou.
</P>
<P>
Beleza, funcionou! Em 17 min varreu 1.3 TiB e copiou 28 arquivos.
</P>
<P>
Mas como nem tudo são flores no mundo encantado da TI, esse método tem pelo menos dois pontos de falha em potencial.
</P>
<P>
Um deles é o tamanho da entrada gerada pela saída do <I>find</I>. No meu Linux 3.16.0 em arquitetura 32 bits, se todos os argumentos do <I>cp</I> resultarem em uma string com mais de 2.097.152 (=2^21, <CODE>bc -l &lt;&lt;&lt; "scale=5;l(2097152)/l(2)"</CODE> ;-) caracteres, ele vai reclamar:
</P>

<PRE>
  $ ( cd "$pesquisa"; find . -type f -iname "$padrao" | wc -c ) # mostra com quantos bytes fica a lista de argumentos resultante do padrão
  2981219
  $ ( cd "$pesquisa"; cp -va --parents $(find . -type f -iname "$padrao") "$destino" )
  bash: /bin/cp: Lista de argumentos muito longa
  $ # ou, em inglês:
  $ ( cd "$pesquisa"; LANGUAGE=C cp -va --parents $(find . -type f -iname "$padrao") "$destino" )
  bash: /bin/cp: Argument list too long
</PRE>

<P>
Podemos até não gostar dessa limitação de 2 MiB, mas lembremos que o "comprimento" dos comandos no terminal do Windows não passa de míseros (8Ki-1)B &gt;:-) (<A HREF="http://goo.gl/Yo1m1e">support.microsoft.com/pt-br/kb/830473</A>)
</P>
<P>
O tamanho que a lista de argumentos pode ter no Unix está definido na constante <B>ARG_MAX</B> e, pelo menos no Linux, pode ser consultado com o comando <I>getconf</I>:
</P>

<PRE>
  $ getconf ARG_MAX
  2097152
  $ getconf -a            # todas as constantes
  $ getconf -a | grep MAX # constantes explicitamente relacionadas a limites máximos, vale a pena uma olhada
</PRE>

<P>
Alguma informação sobre o <B>ARG_MAX</B> está disponível em <A HREF="http://goo.gl/rvN5B5">in-ulm.de/~mascheck/various/argmax/</A>, inclusive uma tabela comparando seu valor em vários sistemas operacionais.
</P>
<P>
Ainda que o processo sobreviva ao risco do tamanho final da lista de parâmetros do <I>cp</I>, pode não escapar da existência de diretórios ou arquivos com espaço no nome (<CODE>/longa/raiz/</CODE><B><CODE>comum a</CODE></B><CODE>/todos/os/arquivos/e/que/nao/interessa/manter/configs/</CODE><B><CODE>putty fileserver.reg</CODE></B>):
</P>

<PRE>
  cp: impossível obter estado de “/longa/raiz/comum”: Arquivo ou diretório não encontrado
  cp: impossível obter estado de “a/todos/os/arquivos/e/que/nao/interessa/manter/configs/putty”: Arquivo ou diretório não encontrado
  cp: impossível obter estado de “fileserver.reg”: Arquivo ou diretório não encontrado
</PRE>

<P>
Para contornar esse outro ponto de falha, precisamos de alguma técnica que permita deixar entre aspas o nome com caminho de cada arquivo, ou o que quer que o represente.
</P>
<P>
Ignorando a alternativa óbvia de iterar a saída do <I>find</I> em um loop, uma <B>segunda técnica</B> permite driblar simultaneamente o problema do tamanho da lista de argumentos e dos espaços em nomes, de pelo menos duas formas:
</P>

<UL>
<LI>executando o <I>cp</I> de dentro do <I>find</I>
<LI>passando o resultado do <I>find</I> via <I>xargs</I> para o <I>cp</I>
</UL>

<PRE>
  $ ( cd "$pesquisa"; time find . -type f -iname "$padrao" -exec cp -va --parents "{}" "$destino" \; )
  $ ( cd "$pesquisa"; time find . -type f -iname "$padrao" | xargs -I+ cp -va --parents "+" "$destino" )
</PRE>

<P>
Por fim, uma <B>terceira técnica</B> combina o comando <I>find</I> com duas chamadas do comando <I>tar</I>. Tem características interessantes:
</P>

<UL>
<LI>é possível compactar o stream antes da cópia, usando parâmetros do próprio <I>tar</I> ou alguma ferramenta auxiliar;
<LI>aliando o comando <I>ssh</I>, é possível transferência criptografada do stream através pela rede;
<LI>uma chave privada sem passphrase para o <I>ssh</I> torna desnecessária a interação humana para autenticação por senha;
<LI>além da compressão por ferramentas auxiliares, o próprio <I>ssh</I> pode efetuar compressão dos dados em seu tráfego. De qualquer forma, é basicamente em redes lentas que ela será útil de fato.
</UL>

<P>
Usando <I>ssh</I>, é especialmente importante verificar se temos as permissões necessárias para criar o diretório <B>$destino</B>.
</P>
<P>
O <I>tar</I> pode ser usado com <I>xargs</I> para contornar o estouro do tamanho da lista de argumentos ou pode usar um arquivo com a lista de entrada a ser manipulada. Para evitar a criação explícita de um arquivo intermediário, podemos aplicar substituição de processos (<A HREF="http://goo.gl/Yt7ofw">apoie.org/JulioNeves/PapoXI.htm#Substitui_o_de_processos</A>, <A HREF="http://goo.gl/IaSYQf">wikipedia.org/wiki/Process_substitution</A>).
</P>

<PRE>
  $ ( cd "$pesquisa"; time find . -type f -iname "$padrao" -print0 | xargs -0 tar cf - ) | tar xvf - -C "$destino"
  
  $ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | tar xvf - -C "$destino"
  
  $ chave="/arquivo/com/chave/privada/sem/passphrase"
  $ remoto="user@host"
  
  $ # compactação gzip
  $ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | ssh -CTi "$chave" $remoto "mkdir -p '$destino'; tar  xvf - -C '$destino'"
  
  $ # compactação bzip2
  $ ( cd "$pesquisa"; tar jcf - -T &lt;(time find . -type f -iname "$padrao") ) | ssh  -Ti "$chave" $remoto "mkdir -p '$destino'; tar jxvf - -C '$destino'"
  
  $ # compactação lzma
  $ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | xz -9e | ssh -Ti "$chave" $remoto "mkdir -p '$destino'; xz -d | tar xvf - -C '$destino'"
</PRE>

<H2>Comandos usados nesse artigo</H2>

<UL>
<LI><A HREF="http://goo.gl/xyWEUj">bash</A>
<LI><A HREF="http://goo.gl/0K1ZMA">bc</A>
<LI><A HREF="http://goo.gl/4lPnHa">cp</A>
<LI><A HREF="http://goo.gl/BYfgvT">find</A>
<LI><A HREF="http://goo.gl/ohvUEn">getconf</A>
<LI><A HREF="http://goo.gl/KlxUdu">grep</A>
<LI><A HREF="http://goo.gl/kyv1cP">ssh</A>
<LI><A HREF="http://goo.gl/uZkT7k">tar</A>
<LI><A HREF="http://goo.gl/XOYu6o">time</A>
<LI><A HREF="http://goo.gl/ad8FI7">wc</A>
<LI><A HREF="http://goo.gl/v2LCEa">xargs</A>
<LI><A HREF="http://goo.gl/39LKqs">xz</A>
<P></P>
</UL>

<!-- html code generated by txt2tags 2.6 (http://txt2tags.org) -->
<!-- cmdline: txt2tags -t html -\-encoding=utf8 -\-style=../style/style.css procurando_e_copiando_arquivos_com_seus_caminhos_originais_num_comando_so.t2t -->
</BODY></HTML>
